% This module implements a pacman game
module pacman

	graph class: DirectedGraph

	exports
		% Starts the game
		transformation unit go;
		% Starts a 'fair' game 
		transformation unit go1

	realized by

		% ---=== Shared transformation units ===---
		% If the pacman is alive we can move him
		transformation unit pacman_alive
			initial:
			body:
				apply once PMmove
			terminal:
		end;

		% ---=== Version 1 ===---

		% Intelligent move of the pacman
		% The pacman does not run into the ghost by himself
		transformation unit pacman_move
			initial:
			body:
				apply once PMmove1 < PMeat < PMmove
			terminal:
		end;

		% Move the pacman or the ghost
		transformation unit move1
			initial:
			body:
				apply once GHmove | pacman_move
			terminal:
		end;

		% The main transformation unit
		% ---=== Version 2 ===---
		transformation unit go1
			initial:
			body:
				call Native.GameStart;
				while (pacman_alive) do
					apply once GHkill < move1
				end;
				call Native.GameOver
			terminal:
		end;

		% Moves the ghost and the pacman ...
		transformation unit move
			initial:

			body:
				apply once GHmove | PMmove | PMeat

			terminal:
		end;

		% The main transformation unit
		transformation unit go
			initial:

			body:
				call Native.GameStart;
				while (pacman_alive) do
					apply once GHkill < move 
				end;
				call Native.GameOver
			terminal:
		end
end.
